﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using OpenNETCF.Telephony;

namespace DeviceDetailsTester
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            LineGeneralInfo deviceInfo = null;
            if (GetDeviceInfo(ref deviceInfo))
            {
                this.listBox1.Items.Add("Manufacturer " + deviceInfo.Manufacturer);
                this.listBox1.Items.Add("Model " + deviceInfo.Model);
                this.listBox1.Items.Add("Revision " + deviceInfo.Revision);
                this.listBox1.Items.Add("IMEI " + deviceInfo.SerialNumber);
                this.listBox1.Items.Add("IMSI " + deviceInfo.SubscriberNumber);
            }

            this.listBox1.Items.Add("OS Version  " + System.Environment.OSVersion);
        }

        /// <summary>
        /// Code from http://blog.opennetcf.com/ncowburn/CommentView,guid,9426ea5f-6052-4e7f-b44c-1d40498d1c62.aspx
        /// </summary>
        /// <param name="deviceInfo"></param>
        /// <returns></returns>
        private static bool GetDeviceInfo(ref LineGeneralInfo deviceInfo)
        {
            bool result = false;
            Telephony phone = new Telephony();

            try
            {
                phone.Initialize();

                if (deviceInfo == null)
                    deviceInfo = new LineGeneralInfo(512);

		        // This is a workaround for a <A href="http://blog.opennetcf.com/ncowburn/ct.ashx?id=9426ea5f-6052-4e7f-b44c-1d40498d1c62&url=http%3a%2f%2fbugzilla.opennetcf.com%2fshow_bug.cgi%3fid%3d111" target=_new>known bug</A>.
                BitConverter.GetBytes(deviceInfo.Data.Length).CopyTo(deviceInfo.Data, 0);

                using (Line line = phone.CreateLine(0, 
                                                MediaMode.InteractiveVoice, 
                                                CallPrivilege.Monitor))
                {
                   if (0 == NativeMethods.lineGetGeneralInfo(line.hLine, deviceInfo.Data))
                   {
                       deviceInfo.Load();
                       result = true;
                   }
                }
            }
            finally
            {
                phone.Shutdown();
            }

            return result;
        }
    }
}